function Rt=calc_Rt(i,j)
global COL 
global pw pg pcgw dpth vb
global twx twx1 tgx tgx1 ttx 
global sw sw_0 dnw dnw_0 sg sg_0 dng dng_0 sh sh_0  T T_0 si si_0
global phi phi_0 dt
global INDC1 INDC2 INDC3 INDC2_old
global dnh dns dni
global Cp_g Cp_h Cp_w Cp_s Cp_i
global qt dy dz L
global T_top pw_top

T0=0;
L=50000*(1/(0.016+5.75*0.018)); % latent heat for hydrate change to water
Li=334000;                      % latent heat for ice change to water
Lhi=L-Li;                       % latent heat for hydrate change to ice
Rt=0;
pg=pw+pcgw;

adv_opt=1;   % if it =0, means no heat advection by water flow
adv_opt_g=1;  % if it=0, means no heat advection by gas flow
T_opt=1;    % T_opt=1, only temperature change, T_opt=2, consider the full derivative of accumulation term one by one, T_opt=3, consider the full derivative of accumulation term together

if i==1
    if adv_opt==1
        if twx(i,j)*(pw(i+1,j)-pw(i,j)) > twx1(i,j)*(dpth(i+1,j)-dpth(i,j))     % if hydraulic head at node i+1 is greater than at node i
            Rt=Rt + twx(i,j)*(pw(i+1,j)-pw(i,j))*dnw(i+1,j)*Cp_w*(T0+T(i+1,j));
            Rt=Rt - twx1(i,j)*(dpth(i+1,j)-dpth(i,j))*dnw(i+1,j)*Cp_w*(T0+T(i+1,j));
        else
            Rt=Rt + twx(i,j)*(pw(i+1,j)-pw(i,j))*dnw(i,j)*Cp_w*(T0+T(i,j));
            Rt=Rt - twx1(i,j)*(dpth(i+1,j)-dpth(i,j))*dnw(i,j)*Cp_w*(T0+T(i,j));
        end
    end
    if adv_opt_g==1
        if tgx(i,j)*(pg(i+1,j)-pg(i,j)) > tgx1(i,j)*(dpth(i+1,j)-dpth(i,j))
            Rt=Rt + tgx(i,j)*(pg(i+1,j)-pg(i,j))*dng(i+1,j)*Cp_g*(T0+T(i+1,j));
            Rt=Rt - tgx1(i,j)*(dpth(i+1,j)-dpth(i,j))*dng(i+1,j)*Cp_g*(T0+T(i+1,j));
        else
            Rt=Rt + tgx(i,j)*(pg(i+1,j)-pg(i,j))*dng(i,j)*Cp_g*(T0+T(i,j));
            Rt=Rt - tgx1(i,j)*(dpth(i+1,j)-dpth(i,j))*dng(i,j)*Cp_g*(T0+T(i,j));
        end
    end
    Rt=Rt + ttx(i,j)*(T(i+1,j)-T(i,j));

    %---------------------top boundary condition-----------------------------
    if adv_opt==1
        if twx(i,j)*(pw(i,j)-pw_top) > twx1(i,j)*(dpth(i,j)-0)     % if hydraulic head at node i+1 is greater than at node i
            Rt=Rt - 2*twx(i,j)*(pw(i,j)-pw_top)*dnw(i,j)*Cp_w*(T0+T(i,j));
            Rt=Rt + 2*twx1(i,j)*(dpth(i,j)-0)*dnw(i,j)*Cp_w*(T0+T(i,j));
        else
            Rt=Rt - 2*twx(i,j)*(pw(i,j)-pw_top)*dnw(i,j)*Cp_w*(T0+T_top);
            Rt=Rt + 2*twx1(i,j)*(dpth(i,j)-0)*dnw(i,j)*Cp_w*(T0+T_top);
        end
    end
    if adv_opt_g==1
        if tgx(i,j)*(pg(i,j)-pw_top) > tgx1(i,j)*(dpth(i,j)-0)
            Rt=Rt - 2*tgx(i,j)*(pg(i,j)-pw_top)*dng(i,j)*Cp_g*(T0+T(i,j));
            Rt=Rt + 2*tgx1(i,j)*(dpth(i,j)-0)*dng(i,j)*Cp_g*(T0+T(i,j));
        else
            Rt=Rt - 2*tgx(i,j)*(pg(i,j)-pw_top)*dng(i,j)*Cp_g*(T0+T_top);
            Rt=Rt + 2*tgx1(i,j)*(dpth(i,j)-0)*dng(i,j)*Cp_g*(T0+T_top);
        end
    end
    Rt=Rt - 2*ttx(i,j)*(T(i,j)-T_top);
    %----------------------------------------------------------------------


elseif i==COL
    if adv_opt==1
        if twx(i-1,j)*(pw(i,j)-pw(i-1,j)) > twx1(i-1,j)*(dpth(i,j)-dpth(i-1,j))
            Rt=Rt - twx(i-1,j)*(pw(i,j)-pw(i-1,j))*dnw(i,j)*Cp_w*(T0+T(i,j));
            Rt=Rt + twx1(i-1,j)*(dpth(i,j)-dpth(i-1,j))*dnw(i,j)*Cp_w*(T0+T(i,j));
        else
            Rt=Rt - twx(i-1,j)*(pw(i,j)-pw(i-1,j))*dnw(i-1,j)*Cp_w*(T0+T(i-1,j));
            Rt=Rt + twx1(i-1,j)*(dpth(i,j)-dpth(i-1,j))*dnw(i-1,j)*Cp_w*(T0+T(i-1,j));
        end
    end
    if adv_opt_g==1
        if tgx(i-1,j)*(pg(i,j)-pg(i-1,j)) > tgx1(i-1,j)*(dpth(i,j)-dpth(i-1,j))
            Rt=Rt - tgx(i-1,j)*(pg(i,j)-pg(i-1,j))*dng(i,j)*Cp_g*(T0+T(i,j));
            Rt=Rt + tgx1(i-1,j)*(dpth(i,j)-dpth(i-1,j))*dng(i,j)*Cp_g*(T0+T(i,j));
        else
            Rt=Rt - tgx(i-1,j)*(pg(i,j)-pg(i-1,j))*dng(i-1,j)*Cp_g*(T0+T(i-1,j));
            Rt=Rt + tgx1(i-1,j)*(dpth(i,j)-dpth(i-1,j))*dng(i-1,j)*Cp_g*(T0+T(i-1,j));
        end
    end

    Rt=Rt - ttx(i-1,j)*(T(i,j)-T(i-1,j));


else
    if adv_opt==1
        if twx(i,j)*(pw(i+1,j)-pw(i,j)) > twx1(i,j)*(dpth(i+1,j)-dpth(i,j))
            Rt=Rt + twx(i,j)*(pw(i+1,j)-pw(i,j))*dnw(i+1,j)*Cp_w*(T0+T(i+1,j));
            Rt=Rt - twx1(i,j)*(dpth(i+1,j)-dpth(i,j))*dnw(i+1,j)*Cp_w*(T0+T(i+1,j));
        else
            Rt=Rt + twx(i,j)*(pw(i+1,j)-pw(i,j))*dnw(i,j)*Cp_w*(T0+T(i,j));
            Rt=Rt - twx1(i,j)*(dpth(i+1,j)-dpth(i,j))*dnw(i,j)*Cp_w*(T0+T(i,j));
        end
    end
    if adv_opt_g==1
        if tgx(i,j)*(pg(i+1,j)-pg(i,j)) > tgx1(i,j)*(dpth(i+1,j)-dpth(i,j))
            Rt=Rt + tgx(i,j)*(pg(i+1,j)-pg(i,j))*dng(i+1,j)*Cp_g*(T0+T(i+1,j));
            Rt=Rt - tgx1(i,j)*(dpth(i+1,j)-dpth(i,j))*dng(i+1,j)*Cp_g*(T0+T(i+1,j));
        else
            Rt=Rt + tgx(i,j)*(pg(i+1,j)-pg(i,j))*dng(i,j)*Cp_g*(T0+T(i,j));
            Rt=Rt - tgx1(i,j)*(dpth(i+1,j)-dpth(i,j))*dng(i,j)*Cp_g*(T0+T(i,j));
        end
    end

    Rt=Rt + ttx(i,j)*(T(i+1,j)-T(i,j));

    if adv_opt==1
        if twx(i-1,j)*(pw(i,j)-pw(i-1,j)) > twx1(i-1,j)*(dpth(i,j)-dpth(i-1,j))
            Rt=Rt - twx(i-1,j)*(pw(i,j)-pw(i-1,j))*dnw(i,j)*Cp_w*(T0+T(i,j));
            Rt=Rt + twx1(i-1,j)*(dpth(i,j)-dpth(i-1,j))*dnw(i,j)*Cp_w*(T0+T(i,j));
        else
            Rt=Rt - twx(i-1,j)*(pw(i,j)-pw(i-1,j))*dnw(i-1,j)*Cp_w*(T0+T(i-1,j));
            Rt=Rt + twx1(i-1,j)*(dpth(i,j)-dpth(i-1,j))*dnw(i-1,j)*Cp_w*(T0+T(i-1,j));
        end
    end
    if adv_opt_g==1
        if tgx(i-1,j)*(pg(i,j)-pg(i-1,j)) > tgx1(i-1,j)*(dpth(i,j)-dpth(i-1,j))
            Rt=Rt - tgx(i-1,j)*(pg(i,j)-pg(i-1,j))*dng(i,j)*Cp_g*(T0+T(i,j));
            Rt=Rt + tgx1(i-1,j)*(dpth(i,j)-dpth(i-1,j))*dng(i,j)*Cp_g*(T0+T(i,j));
        else
            Rt=Rt - tgx(i-1,j)*(pg(i,j)-pg(i-1,j))*dng(i-1,j)*Cp_g*(T0+T(i-1,j));
            Rt=Rt + tgx1(i-1,j)*(dpth(i,j)-dpth(i-1,j))*dng(i-1,j)*Cp_g*(T0+T(i-1,j));
        end
    end


    Rt=Rt - ttx(i-1,j)*(T(i,j)-T(i-1,j));


end






if INDC3(i,j)==1

    if INDC2(i,j) == 1
        switch T_opt
            case 1
                Rt=-Rt + ...
                    vb(i,j)*((phi(i,j)*dnw(i,j)*Cp_w + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt- ...
                    phi(i,j)*dni*Li*(0-si_0(i,j))/dt);
            case 2
                Rt=-Rt + ...
                    vb(i,j)*(phi(i,j)*dnw(i,j)*Cp_w*(T(i,j)-T_0(i,j))/dt + ...
                    phi(i,j)*(T0+T_0(i,j))*sw_0(i,j)*Cp_w*(dnw(i,j)-dnw_0(i,j))/dt + ...
                    phi(i,j)*(T0+T_0(i,j))*Cp_w*dnw(i,j)*(1-sw_0(i,j))/dt+...
                    (1-phi(i,j))*dns*Cp_s*(T(i,j)-T_0(i,j))/dt- ...
                    phi(i,j)*dni*Li*(0-si_0(i,j))/dt);
            case 3
                Rt=-Rt + ...
                    vb(i,j)*((phi(i,j)*dnw(i,j)*Cp_w + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                    (phi_0(i,j)*sw_0(i,j)*dnw_0(i,j)*Cp_w +phi_0(i,j)*(1-sw_0(i,j))*dni*Cp_i+ (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt- ...
                    phi(i,j)*dni*Li*(0-si_0(i,j))/dt);
        end



    elseif INDC2(i,j) == 2
        if INDC1(i,j) == 1
            switch T_opt
                case 1
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j))*dnh*Cp_h) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(1-sw(i,j)-sh_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(0-si_0(i,j))/dt);
                case 2
                    Rt=-Rt + ...
                        vb(i,j)*(phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j))*dnh*Cp_h)*(T(i,j)-T_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*(dnw(i,j)*Cp_w-dnh*Cp_h)*(sw(i,j)-sw_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*sw_0(i,j)*Cp_w*(dnw(i,j)-dnw_0(i,j))/dt + ...
                        (1-phi(i,j))*dns*Cp_s*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(1-sw(i,j)-sh_0(i,j))/dt - ...
                        phi(i,j)*dni*Li*(0-si_0(i,j))/dt);
                case 3
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j))*dnh*Cp_h) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                        (phi_0(i,j)*(sw_0(i,j)*dnw_0(i,j)*Cp_w + (1-sw_0(i,j))*dnh*Cp_h) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(1-sw(i,j)-sh_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(0-si_0(i,j))/dt);
            end
        else
            switch T_opt
                case 1
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(0-sh_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(0-si_0(i,j))/dt);
                case 2
                    Rt=-Rt + ...
                        vb(i,j)*(phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j))*dng(i,j)*Cp_g)*(T(i,j)-T_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*(dnw(i,j)*Cp_w-dng(i,j)*Cp_g)*(sw(i,j)-sw_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*sw_0(i,j)*Cp_w*(dnw(i,j)-dnw_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*(1-sw_0(i,j))*Cp_g*(dng(i,j)-dng_0(i,j))/dt + ...
                        (1-phi(i,j))*dns*Cp_s*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(0-sh_0(i,j))/dt - ...
                        phi(i,j)*dni*Li*(0-si_0(i,j))/dt);
                case 3
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                        (phi_0(i,j)*(sw_0(i,j)*dnw_0(i,j)*Cp_w + (1-sw_0(i,j))*dng_0(i,j)*Cp_g) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(0-sh_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(0-si_0(i,j))/dt);
            end
        end


    elseif INDC2(i,j) == 3
        if INDC1(i,j) == 1
            switch T_opt
                case 1
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j))*dnh*Cp_h) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(1-sw(i,j)-sh_0(i,j))/dt);
                case 2
                    Rt=-Rt + ...
                        vb(i,j)*(phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j))*dnh*Cp_h)*(T(i,j)-T_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*(dnw(i,j)*Cp_w-dnh*Cp_h)*(sw(i,j)-sw_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*sw_0(i,j)*Cp_w*(dnw(i,j)-dnw_0(i,j))/dt + ...
                        (1-phi(i,j))*dns*Cp_s*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(1-sw(i,j)-sh_0(i,j))/dt);
                case 3
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j))*dnh*Cp_h) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                        (phi_0(i,j)*(sw_0(i,j)*dnw_0(i,j)*Cp_w + (1-sw_0(i,j))*dnh*Cp_h) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(1-sw(i,j)-sh_0(i,j))/dt);
            end
        else
            switch T_opt
                case 1
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(0-sh_0(i,j))/dt);
                case 2
                    Rt=-Rt + ...
                        vb(i,j)*(phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j))*dng(i,j)*Cp_g)*(T(i,j)-T_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*(dnw(i,j)*Cp_w-dng(i,j)*Cp_g)*(sw(i,j)-sw_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*sw_0(i,j)*Cp_w*(dnw(i,j)-dnw_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*(1-sw_0(i,j))*Cp_g*(dng(i,j)-dng_0(i,j))/dt + ...
                        (1-phi(i,j))*dns*Cp_s*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(0-sh_0(i,j))/dt);
                case 3
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                        (phi_0(i,j)*(sw_0(i,j)*dnw_0(i,j)*Cp_w + (1-sw_0(i,j))*dng_0(i,j)*Cp_g) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(0-sh_0(i,j))/dt);
            end
        end
    elseif INDC2(i,j) == 4
        if INDC1(i,j) == 1
            switch T_opt
                case 1
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j))*dnh*Cp_h) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(sh(i,j)-sh_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(0-si_0(i,j))/dt);
                case 2
                    Rt=-Rt + ...
                        vb(i,j)*(phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j))*dnh*Cp_h)*(T(i,j)-T_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*(dnw(i,j)*Cp_w-dnh*Cp_h)*(sw(i,j)-sw_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*sw_0(i,j)*Cp_w*(dnw(i,j)-dnw_0(i,j))/dt + ...
                        (1-phi(i,j))*dns*Cp_s*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(sh(i,j)-sh_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(0-si_0(i,j))/dt);
                case 3
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j)-sh(i,j))*dng(i,j)*Cp_g + sh(i,j)*dnh*Cp_h) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                        (phi_0(i,j)*(sw_0(i,j)*dnw_0(i,j)*Cp_w + (1-sw_0(i,j))*dnh*Cp_h) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(sh(i,j)-sh_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(0-si_0(i,j))/dt);

            end
        else
            switch T_opt
                case 1
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(sh(i,j)-sh_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(0-si_0(i,j))/dt);
                case 2
                    Rt=-Rt + ...
                        vb(i,j)*(phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j))*dng(i,j)*Cp_g)*(T(i,j)-T_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*(dnw(i,j)*Cp_w-dng(i,j)*Cp_g)*(sw(i,j)-sw_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*sw_0(i,j)*Cp_w*(dnw(i,j)-dnw_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*(1-sw_0(i,j))*Cp_g*(dng(i,j)-dng_0(i,j))/dt + ...
                        (1-phi(i,j))*dns*Cp_s*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(sh(i,j)-sh_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(0-si_0(i,j))/dt);
                case 3
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j)-sh(i,j))*dng(i,j)*Cp_g + sh(i,j)*dnh*Cp_h) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                        (phi_0(i,j)*(sw_0(i,j)*dnw_0(i,j)*Cp_w + (1-sw_0(i,j))*dng_0(i,j)*Cp_g) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(sh(i,j)-0)/dt- ...
                        phi(i,j)*dni*Li*(0-si_0(i,j))/dt);
                    % 'okRt4'
            end
        end
    else
        switch T_opt
            case 1
                Rt=-Rt + ...
                    vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j)-sh(i,j))*dng(i,j)*Cp_g + sh(i,j)*dnh*Cp_h) + ...
                    (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                    phi(i,j)*dnh*L*(sh(i,j)-sh_0(i,j))/dt);
            case 2
                Rt=-Rt + ...
                    vb(i,j)*(phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j)-sh(i,j))*dng(i,j)*Cp_g + sh(i,j)*dnh*Cp_h)*(T(i,j)-T_0(i,j))/dt + ...
                    phi(i,j)*(T0+T_0(i,j))*(dnw(i,j)*Cp_w-dng(i,j)*Cp_g)*(sw(i,j)-sw_0(i,j))/dt + ...
                    phi(i,j)*(T0+T_0(i,j))*(dnh*Cp_h-dng(i,j)*Cp_g)*(sh(i,j)-sh_0(i,j))/dt + ...
                    phi(i,j)*(T0+T_0(i,j))*sw_0(i,j)*Cp_w*(dnw(i,j)-dnw_0(i,j))/dt + ...
                    phi(i,j)*(T0+T_0(i,j))*(1-sw_0(i,j)-sh_0(i,j))*Cp_g*(dng(i,j)-dng_0(i,j))/dt + ...
                    (1-phi(i,j))*dns*Cp_s*(T(i,j)-T_0(i,j))/dt - ...
                    phi(i,j)*dnh*L*(sh(i,j)-sh_0(i,j))/dt);
            case 3
                Rt=-Rt + ...
                    vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j)-sh(i,j))*dng(i,j)*Cp_g + sh(i,j)*dnh*Cp_h) + ...
                    (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                    (phi_0(i,j)*(sw_0(i,j)*dnw_0(i,j)*Cp_w + (1-sw_0(i,j)-sh_0(i,j))*dng_0(i,j)*Cp_g + sh_0(i,j)*dnh*Cp_h) + ...
                    (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                    phi(i,j)*dnh*L*(sh(i,j)-sh_0(i,j))/dt);
        end
    end % end if INDC2(i,j)==1
end % end if INDC3(i,j)==1






if INDC3(i,j)==2
    if INDC2(i,j) == 2
        if INDC1(i,j) == 1
            switch T_opt
                case 1
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(si(i,j)*dni*Cp_i + (1-si(i,j))*dnh*Cp_h) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*Lhi*(1-si(i,j)-sh_0(i,j))/dt);
                case 2
                    Rt=-Rt + ...
                        vb(i,j)*(phi(i,j)*(si(i,j)*dni*Cp_i + (1-si(i,j))*dnh*Cp_h)*(T(i,j)-T_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*(dni*Cp_i-dnh*Cp_h)*(si(i,j)-si_0(i,j))/dt + ...
                        (1-phi(i,j))*dns*Cp_s*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*Lhi*(1-si(i,j)-sh_0(i,j))/dt);
                case 3
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(si(i,j)*dni*Cp_i + (1-si(i,j))*dnh*Cp_h) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                        (phi_0(i,j)*(si_0(i,j)*dni*Cp_i + (1-si_0(i,j))*dnh*Cp_h) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                        phi(i,j)*dnh*Lhi*(1-si(i,j)-sh_0(i,j))/dt);
            end
        else
            switch T_opt
                case 1
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(si(i,j)*dni*Cp_i + (1-si(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*Lhi*(0-sh_0(i,j))/dt);
                case 2
                    Rt=-Rt + ...
                        vb(i,j)*(phi(i,j)*(si(i,j)*dni*Cp_i + (1-si(i,j))*dng(i,j)*Cp_g)*(T(i,j)-T_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*(dni*Cp_i-dng(i,j)*Cp_g)*(si(i,j)-si_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*(1-si_0(i,j))*Cp_g*(dng(i,j)-dng_0(i,j))/dt + ...
                        (1-phi(i,j))*dns*Cp_s*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*Lhi*(0-sh_0(i,j))/dt);
                case 3
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(si(i,j)*dni*Cp_i + (1-si(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                        (phi_0(i,j)*(si_0(i,j)*dni*Cp_i + (1-si_0(i,j))*dng_0(i,j)*Cp_g) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                        phi(i,j)*dnh*Lhi*(0-sh_0(i,j))/dt);
            end
        end


    elseif INDC2(i,j) == 3
        if INDC1(i,j) == 1
            switch T_opt
                case 1
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(si(i,j)*dni*Cp_i + (1-si(i,j))*dnh*Cp_h) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*Lhi*(1-si(i,j)-sh_0(i,j))/dt);
                case 2
                    Rt=-Rt + ...
                        vb(i,j)*(phi(i,j)*(si(i,j)*dni*Cp_i + (1-si(i,j))*dnh*Cp_h)*(T(i,j)-T_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*(dni*Cp_i-dnh*Cp_h)*(si(i,j)-si_0(i,j))/dt + ...
                        (1-phi(i,j))*dns*Cp_s*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*Lhi*(1-si(i,j)-sh_0(i,j))/dt);
                case 3
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(si(i,j)*dni*Cp_i + (1-si(i,j))*dnh*Cp_h) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                        (phi_0(i,j)*(si_0(i,j)*dni*Cp_i + (1-si_0(i,j))*dnh*Cp_h) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                        phi(i,j)*dnh*Lhi*(1-si(i,j)-sh_0(i,j))/dt);
            end
        else
            switch T_opt
                case 1
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(si(i,j)*dni*Cp_i + (1-si(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*Lhi*(0-sh_0(i,j))/dt);
                case 2
                    Rt=-Rt + ...
                        vb(i,j)*(phi(i,j)*(si(i,j)*dni*Cp_i + (1-si(i,j))*dng(i,j)*Cp_g)*(T(i,j)-T_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*(dni*Cp_i-dng(i,j)*Cp_g)*(si(i,j)-si_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*(1-si_0(i,j))*Cp_g*(dng(i,j)-dng_0(i,j))/dt + ...
                        (1-phi(i,j))*dns*Cp_s*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*Lhi*(0-sh_0(i,j))/dt);
                case 3
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(si(i,j)*dni*Cp_i + (1-si(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                        (phi_0(i,j)*(si_0(i,j)*dni*Cp_i + (1-si_0(i,j))*dng_0(i,j)*Cp_g) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                        phi(i,j)*dnh*Lhi*(0-sh_0(i,j))/dt);
            end
        end
    elseif INDC2(i,j) == 4
        if INDC1(i,j) == 1
            switch T_opt
                case 1
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(si(i,j)*dni*Cp_i + (1-si(i,j))*dnh*Cp_h) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*Lhi*(sh(i,j)-sh_0(i,j))/dt);
                case 2
                    Rt=-Rt + ...
                        vb(i,j)*(phi(i,j)*(si(i,j)*dni*Cp_i + (1-si(i,j))*dnh*Cp_h)*(T(i,j)-T_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*(dni*Cp_i-dnh*Cp_h)*(si(i,j)-si_0(i,j))/dt + ...
                        (1-phi(i,j))*dns*Cp_s*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*Lhi*(sh(i,j)-sh_0(i,j))/dt);
                case 3
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(si(i,j)*dni*Cp_i + (1-si(i,j)-sh(i,j))*dng(i,j)*Cp_g + sh(i,j)*dnh*Cp_h) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                        (phi_0(i,j)*(si_0(i,j)*dni*Cp_i + (1-si_0(i,j))*dnh*Cp_h) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                        phi(i,j)*dnh*Lhi*(sh(i,j)-sh_0(i,j))/dt);

            end
        else
            switch T_opt
                case 1
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(si(i,j)*dni*Cp_i + (1-si(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*Lhi*(sh(i,j)-sh_0(i,j))/dt);
                case 2
                    Rt=-Rt + ...
                        vb(i,j)*(phi(i,j)*(si(i,j)*dni*Cp_i + (1-si(i,j))*dng(i,j)*Cp_g)*(T(i,j)-T_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*(dni*Cp_i-dng(i,j)*Cp_g)*(si(i,j)-si_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*(1-si_0(i,j))*Cp_g*(dng(i,j)-dng_0(i,j))/dt + ...
                        (1-phi(i,j))*dns*Cp_s*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*Lhi*(sh(i,j)-sh_0(i,j))/dt);
                case 3
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(si(i,j)*dni*Cp_i + (1-si(i,j)-sh(i,j))*dng(i,j)*Cp_g + sh(i,j)*dnh*Cp_h) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                        (phi_0(i,j)*(si_0(i,j)*dni*Cp_i + (1-si_0(i,j))*dng_0(i,j)*Cp_g) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                        phi(i,j)*dnh*Lhi*(sh(i,j)-0)/dt);
                    % 'okRt4'
            end
        end
    else
        switch T_opt
            case 1
                Rt=-Rt + ...
                    vb(i,j)*((phi(i,j)*(si(i,j)*dni*Cp_i + (1-si(i,j)-sh(i,j))*dng(i,j)*Cp_g + sh(i,j)*dnh*Cp_h) + ...
                    (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                    phi(i,j)*dnh*Lhi*(sh(i,j)-sh_0(i,j))/dt);
            case 2
                Rt=-Rt + ...
                    vb(i,j)*(phi(i,j)*(si(i,j)*dni*Cp_i + (1-si(i,j)-sh(i,j))*dng(i,j)*Cp_g + sh(i,j)*dnh*Cp_h)*(T(i,j)-T_0(i,j))/dt + ...
                    phi(i,j)*(T0+T_0(i,j))*(dni*Cp_i-dng(i,j)*Cp_g)*(si(i,j)-si_0(i,j))/dt + ...
                    phi(i,j)*(T0+T_0(i,j))*(dnh*Cp_h-dng(i,j)*Cp_g)*(sh(i,j)-sh_0(i,j))/dt + ...
                    phi(i,j)*(T0+T_0(i,j))*(1-si_0(i,j)-si_0(i,j))*Cp_g*(dng(i,j)-dng_0(i,j))/dt + ...
                    (1-phi(i,j))*dns*Cp_s*(T(i,j)-T_0(i,j))/dt - ...
                    phi(i,j)*dnh*Lhi*(sh(i,j)-sh_0(i,j))/dt);
            case 3
                Rt=-Rt + ...
                    vb(i,j)*((phi(i,j)*(si(i,j)*dni*Cp_i + (1-si(i,j)-sh(i,j))*dng(i,j)*Cp_g + sh(i,j)*dnh*Cp_h) + ...
                    (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                    (phi_0(i,j)*(si_0(i,j)*dni*Cp_i + (1-si_0(i,j)-sh_0(i,j))*dng_0(i,j)*Cp_g + sh_0(i,j)*dnh*Cp_h) + ...
                    (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                    phi(i,j)*dnh*Lhi*(sh(i,j)-sh_0(i,j))/dt);
        end
    end % end if INDC2(i,j)==1
end







if INDC3(i,j)==3
    if INDC2(i,j) == 2         % only applies to L changes to L+I
        switch T_opt
            case 1
                Rt=-Rt + ...
                    vb(i,j)*((phi(i,j)*dnw(i,j)*Cp_w*sw(i,j) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt- ...
                    phi(i,j)*dni*Li*(1-sw(i,j)-0)/dt);
            case 2
                Rt=-Rt + ...
                    vb(i,j)*((phi(i,j)*dnw(i,j)*Cp_w*sw(i,j) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt+...
                    phi(i,j)*dnw(i,j)*Cp_w*(T0+T_0(i,j))*(sw(i,j)-1)/dt+...
                    phi(i,j)*(T0+T_0(i,j))*Cp_w*sw(i,j)*(dnw(i,j)-dnw_0(i,j))/dt-...
                    phi(i,j)*dni*Li*(1-sw(i,j)-0)/dt);
            case 3
                Rt=-Rt + ...
                    vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j))*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                    (phi_0(i,j)*(dnw_0(i,j)*Cp_w + 0*dni*Cp_i) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                    phi(i,j)*dni*Li*(1-sw(i,j)-0)/dt);


        end

    elseif INDC2(i,j) == 4
        if sw_0(i,j)>0
            if INDC1(i,j) == 1
                switch T_opt
                    case 1
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w +(1-sw(i,j))*dnh*Cp_h) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                            phi(i,j)*dnh*L*(sh(i,j)-sh_0(i,j))/dt- ...
                            phi(i,j)*dni*Li*(1-sh(i,j)-sw(i,j)-0)/dt);
                    case 2
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w +(1-sw(i,j))*dnh*Cp_h) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt +...
                            phi(i,j)*(T0+T_0(i,j))*(dnw(i,j)*Cp_w-dnh*Cp_h)*(sw(i,j)-sw_0(i,j))/dt + ...
                            phi(i,j)*(T0+T_0(i,j))*sw_0(i,j)*Cp_w*(dnw(i,j)-dnw_0(i,j))/dt - ...
                            phi(i,j)*dnh*L*(sh(i,j)-sh_0(i,j))/dt- ...
                            phi(i,j)*dni*Li*(1-sh(i,j)-sw(i,j)-0)/dt);
                    case 3
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w +(1-sw(i,j)-sh(i,j))*dni*Cp_i+ sh(i,j)*dnh*Cp_h) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                            (phi_0(i,j)*(sw_0(i,j)*dnw_0(i,j)*Cp_w + (1-sw_0(i,j))*dnh*Cp_h) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                            phi(i,j)*dnh*L*(sh(i,j)-sh_0(i,j))/dt- ...
                            phi(i,j)*dni*Li*(1-sh(i,j)-sw(i,j)-0)/dt);
                end
            else
                switch T_opt
                    case 1
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                            phi(i,j)*dni*Li*(1-sg(i,j)-sw(i,j)-0)/dt);
                    case 2
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w +(1-sw(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt +...
                            phi(i,j)*(T0+T_0(i,j))*(dnw(i,j)*Cp_w-dng*Cp_g)*(sw(i,j)-sw_0(i,j))/dt + ...
                            phi(i,j)*(T0+T_0(i,j))*sw_0(i,j)*Cp_w*(dnw(i,j)-dnw_0(i,j))/dt + ...
                            phi(i,j)*(T0+T_0(i,j))*sg_0(i,j)*Cp_g*(dng(i,j)-dng_0(i,j))/dt - ...
                            phi(i,j)*dni*Li*(1-sh(i,j)-sw(i,j)-0)/dt);
                    case 3
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w +(1-sw(i,j)-sg(i,j))*dni*Cp_i+ sg(i,j)*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                            (phi_0(i,j)*(sw_0(i,j)*dnw_0(i,j)*Cp_w + (1-sw_0(i,j))*dng*Cp_g) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                            phi(i,j)*dni*Li*(1-sh(i,j)-sw(i,j)-0)/dt);
                end
            end

        else % if sw_0(i,j)>0

            if INDC1(i,j) == 1
                switch T_opt
                    case 1
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(si(i,j)*dni*Cp_i +(1-si(i,j))*dnh*Cp_h) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                            phi(i,j)*dnh*L*(sh(i,j)-sh_0(i,j))/dt- ...
                            phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt);
                    case 2
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(si(i,j)*dni*Cp_i +(1-si(i,j))*dnh*Cp_h) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt +...
                            phi(i,j)*(T0+T_0(i,j))*(dni*Cp_i-dnh*Cp_h)*(si(i,j)-si_0(i,j))/dt- ...
                            phi(i,j)*dnh*L*(sh(i,j)-sh_0(i,j))/dt- ...
                            phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt);
                    case 3
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(si(i,j)*dni*Cp_i +(1-si(i,j)-sh(i,j))*dnw(i,j)*Cp_w+ sh(i,j)*dnh*Cp_h) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                            (phi_0(i,j)*(si_0(i,j)*dni*Cp_i + (1-si_0(i,j))*dnh*Cp_h) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                            phi(i,j)*dnh*L*(sh(i,j)-sh_0(i,j))/dt- ...
                            phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt);
                end
            else
                switch T_opt
                    case 1
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(si(i,j)*dni*Cp_i +(1-si(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                            phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt);
                    case 2
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(si(i,j)*dni*Cp_i +(1-si(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt +...
                            phi(i,j)*(T0+T_0(i,j))*(dni*Cp_i-dng(i,j)*Cp_g)*(si(i,j)-si_0(i,j))/dt  + ...
                            phi(i,j)*(T0+T_0(i,j))*sg_0(i,j)*Cp_g*(dng(i,j)-dng_0(i,j))/dt - ...
                            phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt);
                    case 3
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(si(i,j)*dni*Cp_i +(1-si(i,j)-sg(i,j))*dnw(i,j)*Cp_w+ sg(i,j)*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                            (phi_0(i,j)*(sw_0(i,j)*dnw_0(i,j)*Cp_w + (1-sw_0(i,j))*dng*Cp_g) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                            phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt);
                end
            end

        end
    elseif INDC2(i,j) == 6
        if sw_0(i,j)>0
            switch T_opt
                case 1
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + sh(i,j)*dnh*Cp_h+(1-sw(i,j)-sh(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(sh(i,j)-sh_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(si(i,j)-0)/dt);
                case 2
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + sh(i,j)*dnh*Cp_h+(1-sw(i,j)-sh(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt+...
                        phi(i,j)*(T0+T_0(i,j))*(dnw(i,j)*Cp_w-dng(i,j)*Cp_g)*(sw(i,j)-sw_0(i,j))/dt+...
                        phi(i,j)*(T0+T_0(i,j))*(dnh*Cp_h-dng(i,j)*Cp_g)*(sh(i,j)-sh_0(i,j))/dt+...
                        phi(i,j)*(T0+T_0(i,j))*sw_0(i,j)*Cp_w*(dnw(i,j)-dnw_0(i,j))/dt+...
                        phi(i,j)*(T0+T_0(i,j))*sg_0(i,j)*Cp_g*(dng(i,j)-dng_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(sh(i,j)-sh_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(si(i,j)-0)/dt);
                case 3
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w +sh(i,j)*dnh*Cp_h+si(i,j)*dni*Cp_i+(1-sw(i,j)-sh(i,j)-si(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                        (phi_0(i,j)*(sw_0(i,j)*dnw_0(i,j)*Cp_w + sh_0(i,j)*dnh*Cp_h+(1-sw_0(i,j)-sh_0(i,j))*dng_0(i,j)*Cp_g) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(sh(i,j)-sh_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(si(i,j)-0)/dt);
            end
        else
            switch T_opt
                case 1
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(si(i,j)*dni*Cp_i + sh(i,j)*dnh*Cp_h+(1-si(i,j)-sh(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(sh(i,j)-sh_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(si(i,j)-0)/dt);
                case 2
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(si(i,j)*dni*Cp_i + sh(i,j)*dnh*Cp_h+(1-si(i,j)-sh(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt+...
                        phi(i,j)*(T0+T_0(i,j))*(dni*Cp_i-dng(i,j)*Cp_g)*(si(i,j)-si_0(i,j))/dt+...
                        phi(i,j)*(T0+T_0(i,j))*(dnh*Cp_h-dng(i,j)*Cp_g)*(sh(i,j)-sh_0(i,j))/dt+...
                        phi(i,j)*(T0+T_0(i,j))*sg_0(i,j)*Cp_g*(dng(i,j)-dng_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(sh(i,j)-sh_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(si(i,j)-0)/dt);
                case 3
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w +sh(i,j)*dnh*Cp_h+si(i,j)*dni*Cp_i+(1-sw(i,j)-sh(i,j)-si(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                        (phi_0(i,j)*(si_0(i,j)*dni*Cp_i + sh_0(i,j)*dnh*Cp_h+(1-si_0(i,j)-sh_0(i,j))*dng_0(i,j)*Cp_g) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                        phi(i,j)*dnh*L*(sh(i,j)-sh_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(si(i,j)-0)/dt);
            end
        end
    end % end if INDC2(i,j)==2
end








if INDC3(i,j)==4
    if INDC2(i,j) == 3
        switch T_opt
            case 1
                Rt=-Rt + ...
                    vb(i,j)*((phi(i,j)*sw(i,j)*dnw(i,j)*Cp_w+phi(i,j)*(1-sw(i,j))*dni*Cp_i + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt- ...
                    phi(i,j)*dni*Li*(1-sw(i,j)-si_0(i,j))/dt);
            case 2
                Rt=-Rt + ...
                    vb(i,j)*((phi(i,j)*sw(i,j)*dnw(i,j)*Cp_w+phi(i,j)*(1-sw(i,j))*dni*Cp_i + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt+...
                    phi(i,j)*(T0+T_0(i,j))*(dnw(i,j)*Cp_w-dni*Cp_i)*(sw(i,j)-sw_0(i,j))/dt+...
                    phi(i,j)*(T0+T_0(i,j))*sw_0(i,j)*Cp_w*(dnw(i,j)-dnw_0(i,j))/dt- ...
                    phi(i,j)*dni*Li*(1-sw(i,j)-si_0(i,j))/dt);
            case 3
                Rt=-Rt + ...
                    vb(i,j)*((phi(i,j)*sw(i,j)*dnw(i,j)*Cp_w +phi(i,j)*(1-sw(i,j))*dni*Cp_i+ (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                    (phi_0(i,j)*sw_0(i,j)*dnw_0(i,j)*Cp_w +phi_0(i,j)*(1-sw_0(i,j))*dni*Cp_i+ (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt- ...
                    phi(i,j)*dni*Li*(1-sw(i,j)-si_0(i,j))/dt);
        end
    elseif INDC2(i,j)==4
        if INDC2_old(i,j)==7
            if INDC1(i,j)==1
                switch T_opt
                    case 1
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + sh(i,j)*dnh*Cp_h+(1-sw(i,j)-sh(i,j))*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                            phi(i,j)*dnh*Lhi*(sh(i,j)-sh_0(i,j))/dt- ...
                            phi(i,j)*dni*Li*(1-sw(i,j)-sh(i,j)-si_0(i,j))/dt);
                    case 2
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + sh(i,j)*dnh*Cp_h+(1-sw(i,j)-sh(i,j))*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt +...
                            phi(i,j)*(T0+T_0(i,j))*(dnw(i,j)*Cp_w-dni*Cp_i)*(sw(i,j)-sw_0(i,j))/dt + ...
                            phi(i,j)*(T0+T_0(i,j))*sw_0(i,j)*Cp_w*(dnw(i,j)-dnw_0(i,j))/dt + ...
                            phi(i,j)*(T0+T_0(i,j))*(dnh*Cp_h-dni*Cp_i)*(sh(i,j)-sh_0(i,j))/dt- ...
                            phi(i,j)*dnh*Lhi*(sh(i,j)-sh_0(i,j))/dt- ...
                            phi(i,j)*dni*Li*(1-sw(i,j)-sh(i,j)-si_0(i,j))/dt);
                    case 3
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + sh(i,j)*dnh*Cp_h+(1-sw(i,j)-sh(i,j))*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                            (phi_0(i,j)*(sw_0(i,j)*dnw_0(i,j)*Cp_w + sh_0(i,j)*dnh*Cp_h+si_0(i,j)*dni*Cp_i+(1-sw_0(i,j)-sh_0(i,j)-si_0(i,j))*dng_0(i,j)*Cp_g) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                            phi(i,j)*dnh*Lhi*(sh(i,j)-sh_0(i,j))/dt- ...
                            phi(i,j)*dni*Li*(1-sw(i,j)-sh(i,j)-si_0(i,j))/dt);
                end
            else
                switch T_opt
                    case 1
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j)-si(i,j))*dng(i,j)*Cp_g+si(i,j)*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                            phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt- ...
                            phi(i,j)*dnh*Lhi*(0-sh_0(i,j))/dt);
                    case 2
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j)-si(i,j))*dng(i,j)*Cp_g+si(i,j)*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt +...
                            phi(i,j)*(T0+T_0(i,j))*(dnw(i,j)*Cp_w-dng(i,j)*Cp_g)*(sw(i,j)-sw_0(i,j))/dt + ...
                            phi(i,j)*(T0+T_0(i,j))*sw_0(i,j)*Cp_w*(dnw(i,j)-dnw_0(i,j))/dt + ...
                            phi(i,j)*(T0+T_0(i,j))*(dni*Cp_i-dng(i,j)*Cp_g)*(si(i,j)-si_0(i,j))/dt+ ...
                            phi(i,j)*(T0+T_0(i,j))*sg_0(i,j)*Cp_g*(dng(i,j)-dng_0(i,j))/dt- ...
                            phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt- ...
                            phi(i,j)*dnh*Lhi*(0-sh_0(i,j))/dt);
                    case 3
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j)-si(i,j))*dng(i,j)*Cp_g+si(i,j)*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                            (phi_0(i,j)*(sw_0(i,j)*dnw_0(i,j)*Cp_w + sh_0(i,j)*dnh*Cp_h+si_0(i,j)*dni*Cp_i+(1-sw_0(i,j)-sh_0(i,j)-si_0(i,j))*dng_0(i,j)*Cp_g) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                            phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt- ...
                            phi(i,j)*dnh*Lhi*(0-sh_0(i,j))/dt);
                end
            end
        elseif INDC2_old(i,j)==3
            if INDC1(i,j)==1
                switch T_opt
                    case 1
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + sh(i,j)*dnh*Cp_h+(1-sw(i,j)-sh(i,j))*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                            phi(i,j)*dnh*Lhi*(sh(i,j)-0)/dt- ...
                            phi(i,j)*dni*Li*(1-sw(i,j)-sh(i,j)-si_0(i,j))/dt);
                    case 2
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + sh(i,j)*dnh*Cp_h+(1-sw(i,j)-sh(i,j))*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt +...
                            phi(i,j)*(T0+T_0(i,j))*(dnw(i,j)*Cp_w-dni*Cp_i)*(sw(i,j)-sw_0(i,j))/dt + ...
                            phi(i,j)*(T0+T_0(i,j))*sw_0(i,j)*Cp_w*(dnw(i,j)-dnw_0(i,j))/dt + ...
                            phi(i,j)*(T0+T_0(i,j))*(dnh*Cp_h-dni*Cp_i)*(sh(i,j)-sh_0(i,j))/dt- ...
                            phi(i,j)*dnh*Lhi*(sh(i,j)-0)/dt- ...
                            phi(i,j)*dni*Li*(1-sw(i,j)-sh(i,j)-si_0(i,j))/dt);
                    case 3
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + sh(i,j)*dnh*Cp_h+(1-sw(i,j)-sh(i,j))*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                            (phi_0(i,j)*(sw_0(i,j)*dnw_0(i,j)*Cp_w +(1-sw_0(i,j))*dni*Cp_i) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                            phi(i,j)*dnh*Lhi*(sh(i,j)-0)/dt- ...
                            phi(i,j)*dni*Li*(1-sw(i,j)-sh(i,j)-si_0(i,j))/dt);
                end
            else
                switch T_opt
                    case 1
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j)-si(i,j))*dng(i,j)*Cp_g+si(i,j)*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                            phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt);
                    case 2
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j)-si(i,j))*dng(i,j)*Cp_g+si(i,j)*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt +...
                            phi(i,j)*(T0+T_0(i,j))*(dnw(i,j)*Cp_w-dng(i,j)*Cp_g)*(sw(i,j)-sw_0(i,j))/dt + ...
                            phi(i,j)*(T0+T_0(i,j))*sw_0(i,j)*Cp_w*(dnw(i,j)-dnw_0(i,j))/dt + ...
                            phi(i,j)*(T0+T_0(i,j))*(dni*Cp_i-dng(i,j)*Cp_g)*(si(i,j)-si_0(i,j))/dt+ ...
                            phi(i,j)*(T0+T_0(i,j))*sg_0(i,j)*Cp_g*(dng(i,j)-dng_0(i,j))/dt- ...
                            phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt);
                    case 3
                        Rt=-Rt + ...
                            vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j)-si(i,j))*dng(i,j)*Cp_g+si(i,j)*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                            (phi_0(i,j)*(sw_0(i,j)*dnw_0(i,j)*Cp_w +(1-sw_0(i,j))*dni*Cp_i) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                            phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt);
                end
            end

        end

    elseif INDC2(i,j) == 5
        if INDC1(i,j) == 1
            switch T_opt
                case 1
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + sh(i,j)*dnh*Cp_h+(1-sw(i,j)-sh(i,j))*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*Lhi*(sh(i,j)-sh_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(1-sw(i,j)-sh(i,j)-si_0(i,j))/dt);
                case 2
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + sh(i,j)*dnh*Cp_h+(1-sw(i,j)-sh(i,j))*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt +...
                        phi(i,j)*(T0+T_0(i,j))*(dnw(i,j)*Cp_w-dni*Cp_i)*(sw(i,j)-sw_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*sw_0(i,j)*Cp_w*(dnw(i,j)-dnw_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*(dnh*Cp_h-dni*Cp_i)*(sh(i,j)-sh_0(i,j))/dt- ...
                        phi(i,j)*dnh*Lhi*(sh(i,j)-sh_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(1-sw(i,j)-sh(i,j)-si_0(i,j))/dt);
                case 3
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + sh(i,j)*dnh*Cp_h+(1-sw(i,j)-sh(i,j))*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                        (phi_0(i,j)*(sw_0(i,j)*dnw_0(i,j)*Cp_w + sh_0(i,j)*dnh*Cp_h+(1-sw_0(i,j)-sh_0(i,j))*dni*Cp_i) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                        phi(i,j)*dnh*Lhi*(sh(i,j)-sh_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(1-sw(i,j)-sh(i,j)-si_0(i,j))/dt);
            end
        else
            switch T_opt
                case 1
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j)-si(i,j))*dng(i,j)*Cp_g+si(i,j)*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt);
                case 2
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j)-si(i,j))*dng(i,j)*Cp_g+si(i,j)*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt +...
                        phi(i,j)*(T0+T_0(i,j))*(dnw(i,j)*Cp_w-dng(i,j)*Cp_g)*(sw(i,j)-sw_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*sw_0(i,j)*Cp_w*(dnw(i,j)-dnw_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*(dni*Cp_i-dng(i,j)*Cp_g)*(si(i,j)-si_0(i,j))/dt+ ...
                        phi(i,j)*(T0+T_0(i,j))*sg_0(i,j)*Cp_g*(dng(i,j)-dng_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt);
                case 3
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j)-si(i,j))*dng(i,j)*Cp_g+si(i,j)*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                        (phi_0(i,j)*(sw_0(i,j)*dnw_0(i,j)*Cp_w + (1-sw_0(i,j)-si_0(i,j))*dng_0(i,j)*Cp_g+si_0(i,j)*dni*Cp_i) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                        phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt);
            end
        end
    elseif INDC2(i,j) == 6
        if INDC1(i,j) == 1
            switch T_opt
                case 1
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + sh(i,j)*dnh*Cp_h+(1-sw(i,j)-sh(i,j))*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dnh*Lhi*(sh(i,j)-sh_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt);
                case 2
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + sh(i,j)*dnh*Cp_h+(1-sw(i,j)-sh(i,j))*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt +...
                        phi(i,j)*(T0+T_0(i,j))*(dnw(i,j)*Cp_w-dni*Cp_i)*(sw(i,j)-sw_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*sw_0(i,j)*Cp_w*(dnw(i,j)-dnw_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*(dnh*Cp_h-dni*Cp_i)*(sh(i,j)-sh_0(i,j))/dt- ...
                        phi(i,j)*dnh*Lhi*(sh(i,j)-sh_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt);
                case 3
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + sh(i,j)*dnh*Cp_h+si(i,j)*dni*Cp_i+(1-sw(i,j)-sh(i,j)-si(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                        (phi_0(i,j)*(sw_0(i,j)*dnw_0(i,j)*Cp_w + sh_0(i,j)*dnh*Cp_h+(1-sw_0(i,j)-sh_0(i,j))*dni*Cp_i) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                        phi(i,j)*dnh*Lhi*(sh(i,j)-sh_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt);
            end
        else
            switch T_opt
                case 1
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j)-si(i,j))*dng(i,j)*Cp_g+si(i,j)*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                        phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt- ...
                        phi(i,j)*dnh*Lhi*(sh(i,j)-0)/dt);
                case 2
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j)-si(i,j))*dng(i,j)*Cp_g+si(i,j)*dni*Cp_i) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt +...
                        phi(i,j)*(T0+T_0(i,j))*(dnw(i,j)*Cp_w-dng(i,j)*Cp_g)*(sw(i,j)-sw_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*sw_0(i,j)*Cp_w*(dnw(i,j)-dnw_0(i,j))/dt + ...
                        phi(i,j)*(T0+T_0(i,j))*(dni*Cp_i-dng(i,j)*Cp_g)*(si(i,j)-si_0(i,j))/dt+ ...
                        phi(i,j)*(T0+T_0(i,j))*sg_0(i,j)*Cp_g*(dng(i,j)-dng_0(i,j))/dt- ...
                        phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt- ...
                        phi(i,j)*dnh*Lhi*(sh(i,j)-0)/dt);
                case 3
                    Rt=-Rt + ...
                        vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + (1-sw(i,j)-si(i,j)-sh(i,j))*dng(i,j)*Cp_g+si(i,j)*dni*Cp_i+sh(i,j)*dnh*Cp_h) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                        (phi_0(i,j)*(sw_0(i,j)*dnw_0(i,j)*Cp_w + (1-sw_0(i,j)-si_0(i,j))*dng_0(i,j)*Cp_g+si_0(i,j)*dni*Cp_i) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                        phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt- ...
                        phi(i,j)*dnh*Lhi*(sh(i,j)-0)/dt);
            end
        end
    elseif INDC2(i,j) == 7
        switch T_opt
            case 1
                Rt=-Rt + ...
                    vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + sh(i,j)*dnh*Cp_h+si(i,j)*dni*Cp_i+(1-sw(i,j)-sh(i,j)-si(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt - ...
                    phi(i,j)*dnh*Lhi*(sh(i,j)-sh_0(i,j))/dt- ...
                    phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt);
            case 2
                Rt=-Rt + ...
                    vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + sh(i,j)*dnh*Cp_h+si(i,j)*dni*Cp_i+(1-sw(i,j)-sh(i,j)-si(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T(i,j)-T_0(i,j))/dt +...
                    phi(i,j)*(T0+T_0(i,j))*(dnw(i,j)*Cp_w-dng(i,j)*Cp_g)*(sw(i,j)-sw_0(i,j))/dt + ...
                    phi(i,j)*(T0+T_0(i,j))*sw_0(i,j)*Cp_w*(dnw(i,j)-dnw_0(i,j))/dt + ...
                    phi(i,j)*(T0+T_0(i,j))*(dnh*Cp_h-dng(i,j)*Cp_g)*(sh(i,j)-sh_0(i,j))/dt+ ...
                    phi(i,j)*(T0+T_0(i,j))*(dni*Cp_i-dng(i,j)*Cp_g)*(si(i,j)-si_0(i,j))/dt- ...
                    phi(i,j)*dnh*Lhi*(sh(i,j)-sh_0(i,j))/dt- ...
                    phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt);
            case 3
                Rt=-Rt + ...
                    vb(i,j)*((phi(i,j)*(sw(i,j)*dnw(i,j)*Cp_w + sh(i,j)*dnh*Cp_h+si(i,j)*dni*Cp_i+(1-sw(i,j)-sh(i,j)-si(i,j))*dng(i,j)*Cp_g) + (1-phi(i,j))*dns*Cp_s)*(T0+T(i,j))/dt - ...
                    (phi_0(i,j)*(sw_0(i,j)*dnw_0(i,j)*Cp_w + sh_0(i,j)*dnh*Cp_h+si_0(i,j)*dni*Cp_i+(1-sw_0(i,j)-sh_0(i,j)-si_0(i,j))*dng_0(i,j)*Cp_g) + (1-phi_0(i,j))*dns*Cp_s)*(T0+T_0(i,j))/dt - ...
                    phi(i,j)*dnh*Lhi*(sh(i,j)-sh_0(i,j))/dt- ...
                    phi(i,j)*dni*Li*(si(i,j)-si_0(i,j))/dt);
        end
    end % end if INDC2(i,j)==3
end


if i==COL
    Rt=Rt-dy(i,j)*dz(i,j)*qt;

end
end





